# -*- Autoconf -*-
#
# SYNOPSIS
#
#   SST_CHECK_ZOLTAN
#
# DESCRIPTION
#
# LICENSE
#

AC_DEFUN([SST_CHECK_ZOLTAN],
[
  AC_REQUIRE([SST_CHECK_PARMETIS])

  AC_ARG_WITH([zoltan],
    [AS_HELP_STRING([--with-zoltan@<:@=DIR@:>@],
      [Use Zoltan package installed in optionally specified DIR])])

  AS_IF([test "$with_zoltan" = "no"], [happy="no"])

  CPPFLAGS_saved="$CPPFLAGS"
  LDFLAGS_saved="$LDFLAGS"

  AS_IF([test ! -z "$with_zoltan" -a "$with_zoltan" != "yes"],
    [ZOLTAN_CPPFLAGS="-I$with_zoltan/include"
     CPPFLAGS="$PARMETIS_CPPFLAGS $ZOLTAN_CPPFLAGS $CPPFLAGS"
     ZOLTAN_LDFLAGS="-L$with_zoltan/lib"
     LDFLAGS="$PARMETIS_LDFLAGS $ZOLTAN_LDFLAGS $LDFLAGS"],
    [ZOLTAN_CPPFLAGS=
     ZOLTAN_LDFLAGS=])

  AC_CHECK_HEADERS([zoltan.h], [], [happy="no"])
  AC_CHECK_LIB([zoltan], [Zoltan_Initialize], 
    [ZOLTAN_LIB="-lzoltan"], [happy="no"], [$PARMETIS_LIB])

  CPPFLAGS="$CPPFLAGS_saved"
  LDFLAGS="$LDFLAGS_saved"

  AC_SUBST([ZOLTAN_CPPFLAGS])
  AC_SUBST([ZOLTAN_LDFLAGS])
  AC_SUBST([ZOLTAN_LIB])

  AS_IF([test "$happy" = "yes"], [$1], [$2])
])
