dnl -*- Autoconf -*-

AC_DEFUN([SST_CONFIGURE_ELEMENTS], [
  m4_ifdef([sst_elemlib_list], [],
    [m4_fatal([Could not find element library list - rerun autogen.sh])])

  dist_elemlibs=
  active_ltlibs=
  active_elemlibs=

  m4_foreach(sst_elemlib, 
    [sst_elemlib_list], 
    [AS_IF([test ! -f [${srcdir}/sst/elements/]sst_elemlib[/.nodist]],
           [dist_elemlibs="$dist_elemlibs sst_elemlib"])
     SST_CONFIGURE_ELEMLIB(sst_elemlib,
       [active_elemlibs="$active_elemlibs sst_elemlib"
        AS_IF([test "sst_elemlib" != "include"],
              [active_ltlibs="$active_ltlibs "'-dlopen [$(top_builddir)/sst/elements/]sst_elemlib[/lib]sst_elemlib[.la']])
        AS_IF([test -f [${srcdir}/sst/elements/]sst_elemlib[/.nodist]],
              [AC_MSG_WARN([Element library ]sst_elemlib[ will build but not be distributed.])])])])

  SST_DIST_ELEMLIBS="$dist_elemlibs"
  SST_ACTIVE_ELEMLIBS="$active_elemlibs"
  if test $use_ltdl -eq 1 ; then
    SST_LTLIBS_ELEMLIBS="$active_ltlibs"
  fi

  AC_SUBST(SST_DIST_ELEMLIBS)
  AC_SUBST(SST_ACTIVE_ELEMLIBS)
  AC_SUBST(SST_LTLIBS_ELEMLIBS)
])


AC_DEFUN([SST_CONFIGURE_ELEMLIB], [
  AC_MSG_NOTICE([Element library $1])

  m4_ifdef([SST_]$1[_CONFIG],
           [SST_$1_CONFIG([should_build=1], [should_build=0])],
           [should_build=1])

  AC_MSG_CHECKING([if $1 can build])
  AS_IF([test $should_build -eq 1],
        [AC_MSG_RESULT([yes])
         $2], 
        [AC_MSG_RESULT([no])
         $3])

  AC_CONFIG_FILES([sst/elements/]$1[/Makefile])
])
