dnl -*- Autoconf -*-

AC_DEFUN([SST_PHXSimC_CONFIG], [
  AC_ARG_WITH([phxsim],
    [AS_HELP_STRING([--with-phxsim@<:@=DIR@:>@],
      [Use PHXSim package installed in optionally specified DIR])])

  AS_IF([test "$with_phxsim" = "no"], [happy="no"])

  CPPFLAGS_saved="$CPPFLAGS"
  LDFLAGS_saved="$LDFLAGS"

  AS_IF([test ! -z "$with_phxsim" -a "$with_phxsim" != "yes"],
    [PHXSIM_CPPFLAGS="-I$with_phxsim"
     CPPFLAGS="$PHXSIM_CPPFLAGS $CPPFLAGS"
     PHXSIM_LDFLAGS="-L$with_phxsim"
     LDFLAGS="$PHXSIM_LDFLAGS $LDFLAGS"],
    [PHXSIM_CPPFLAGS=
     PHXSIM_LDFLAGS=])

  AC_LANG_PUSH(C++)
  AC_CHECK_HEADERS([phxsim.h], [], [happy="no"])
  AC_CHECK_LIB([phxsim], [libphxsim_is_present], 
	[PHXSIM_LIB="-lphxsim"], [happy="no"])
  AC_LANG_POP(C++)

  CPPFLAGS="$CPPFLAGS_saved"
  LDFLAGS="$LDFLAGS_saved"

  AC_SUBST([PHXSIM_CPPFLAGS])
  AC_SUBST([PHXSIM_LDFLAGS])
  AC_SUBST([PHXSIM_LIB])

  AS_IF([test "$happy" = "yes"], [$1], [$2])
])
