// Copyright 2009-2010 Sandia Corporation. Under the terms
// of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
// Government retains certain rights in this software.
// 
// Copyright (c) 2009-2010, Sandia Corporation
// All rights reserved.
// 
// This file is part of the SST software package. For license
// information, see the LICENSE file in the top level directory of the
// distribution.


/*
 *
 * Copyright 2008 Sandia Corporation. Under the terms
 * of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
 * Government retains certain rights in this software.
 * 
 * Copyright (c) 2009, Sandia Corporation
 * All rights reserved.
 * 
 * This file is part of the SST software package. For license
 * information, see the LICENSE file in the top level directory of the
 * distribution.
 */

/*
** This file contains definitions that are shared betwenn the user level
** and the netsim model (component) inside the SST simulator. Mainly, it
** enumerates the various netsim calls so they can be addressed with a small
** integer, and it defies a data structure that contains the information
** passed when a user calls one of the netsim functions.
*/
#ifndef NETSIM_INTERNAL_H
#define NETSIM_INTERNAL_H

#include <stdint.h>
#include "netsim.h"

#ifdef __cplusplus
extern "C" {
#endif


typedef enum   {
    NETSIM_INIT= 600,
    NETSIM_FINALIZE,
    NETSIM_SIZE,
    NETSIM_RANK,
    NETSIM_TX_START,
    NETSIM_RX_START,
    NETSIM_PROBE_START,
    NETSIM_CQ_POLL,
    NETSIM_GET_CLOCK
} netsim_routine_t;

typedef enum   {
    INIT_ANSWER= 900,
    RCV_COMPLETION,
    SND_COMPLETION
} params_response_t;

// Make sure alignment and size are portable
// in netsim_params_t
typedef struct netsim_params_t   {
    volatile uint32_t rc; // Must be first!!!
    uint32_t synchronous;
    uint64_t buf;
    uint64_t match_bits;
    uint64_t user_data;
    uint64_t ignore_bits;
    uint32_t dest;
    uint32_t msgSize;
    uint32_t my_rank;
    uint32_t nranks;
    uint32_t type;
    uint32_t status;
    // uint32_t padding;
} netsim_params_t;

#ifdef __cplusplus
}
#endif

#endif /* ifndef NETSIM_INTERNAL_H */
