// Copyright 2009-2010 Sandia Corporation. Under the terms
// of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
// Government retains certain rights in this software.
// 
// Copyright (c) 2009-2010, Sandia Corporation
// All rights reserved.
// 
// This file is part of the SST software package. For license
// information, see the LICENSE file in the top level directory of the
// distribution.


#include "mpi_internal.h"

int
MPI_Get_count(MPI_Status *status, MPI_Datatype dtype, int *count)
{
    int ret = MPI_SUCCESS;

    *count = status->st_length / dtype_sizes[dtype];
    if (status->st_length % dtype_sizes[dtype] != 0) ret = MPI_ERR_TYPE;

    return mpi_error_check("MPI_Get_count/MPI_Get_elements", ret);
}


/* elements and count are same if you only support primitive dtypes */
int
MPI_Get_elements(MPI_Status *status, MPI_Datatype dtype, int *count)
{
    return MPI_Get_count(status, dtype, count);
}
