// Copyright 2009-2010 Sandia Corporation. Under the terms
// of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
// Government retains certain rights in this software.
// 
// Copyright (c) 2009-2010, Sandia Corporation
// All rights reserved.
// 
// This file is part of the SST software package. For license
// information, see the LICENSE file in the top level directory of the
// distribution.


#include "mpi_internal.h"

#include <stdio.h>
#include <stdlib.h>


int
MPI_Iprobe(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status)
{
    int ret;
    ret = mpi_int_probe(source, tag, comm, status);
    if (0 == ret) *flag = 1;
    return mpi_error_check("MPI_Iprobe", ret);
}


int
MPI_Probe(int source, int tag, MPI_Comm comm, MPI_Status *status)
{
    int ret = 2;

    while (2 == ret) {
        ret = mpi_int_probe(source, tag, comm, status);
    }
    return mpi_error_check("MPI_Probe", ret);
}
