// Copyright 2009-2010 Sandia Corporation. Under the terms
// of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
// Government retains certain rights in this software.
// 
// Copyright (c) 2009-2010, Sandia Corporation
// All rights reserved.
// 
// This file is part of the SST software package. For license
// information, see the LICENSE file in the top level directory of the
// distribution.


#include "mpi_internal.h"


int
MPI_Irecv(void *buf, int count, MPI_Datatype dtype,
          int source, int tag, MPI_Comm comm, 
          MPI_Request *req)
{
    return mpi_error_check("MPI_Irecv",
                           mpi_int_recv(buf, count, dtype, source, tag, comm, req));
}


int
MPI_Recv(void *buf, int count, MPI_Datatype dtype, 
         int source, int tag, MPI_Comm comm, 
         MPI_Status *status)
{
    MPI_Request req;
    int ret;

    ret = mpi_int_recv(buf, count, dtype, source, tag, comm, &req);
    if (MPI_SUCCESS != ret) return mpi_error_check("MPI_Recv", ret);

    return mpi_error_check("MPI_Recv", 
                           mpi_int_request_wait(&req, status));
}
