// Copyright 2009-2010 Sandia Corporation. Under the terms
// of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
// Government retains certain rights in this software.
// 
// Copyright (c) 2009-2010, Sandia Corporation
// All rights reserved.
// 
// This file is part of the SST software package. For license
// information, see the LICENSE file in the top level directory of the
// distribution.


#include <stdio.h>
#include <malloc/malloc.h>	// For malloc_printf()
#define malloc_printf	printf	/* Seems to work now on x86 */
#include <netsim.h>


#define IDSTR	"test_init __________ "


int 
main(int argc, char *argv[])
{

int rc;
int my_rank;
int nranks;
double t1, t2;

    t1= netsim_get_clock();
    malloc_printf("%s Calling netsim_init()\n", IDSTR);
    rc= netsim_init();
    malloc_printf("%s Back from netsim_init(), rc = %d\n", IDSTR, rc);

    my_rank= netsim_rank();
    nranks= netsim_size();
    malloc_printf("%s My rank is %d/%d\n", IDSTR, my_rank, nranks);

    rc= netsim_finalize();
    malloc_printf("%s Back from netsim_finalize(), rc = %d\n", IDSTR, rc);

    t2= netsim_get_clock();
    malloc_printf("%s Time to execute: %gs\n", IDSTR, t2 - t1);
    return 0;

}  /* end of main() */
